/**
 * 在android环境中,检测本次启动是否是restore重启回来的 , 并且获取plugin的操作结果
 *
 * Created by TonyJiang on 16/4/13.
 */

import RestoreStatusPlugin from 'chanjet-plugin-restore-status'

class AndroidRestore{

    constructor() {
        this._isRestore = false;
        this._restorePluginData = {};

        this.plugin = new RestoreStatusPlugin();

    }

    ready(callback){
        mutants.plugin.restoreStatus.getStatus(this._queryRestoreHandler.bind(this , callback));
    }

    _queryRestoreHandler(callback , rs){
        
        const {resultCode , body} = rs;

        //新版本安卓才会有插件,根据resultCode判断是否调用成功
        if(resultCode == 0){
            const {isFromRestore , restoreList} = body.data;

            this._isReady = true;
            this._isRestore = isFromRestore;

            for(let i = 0 ; i < restoreList.length ; i ++){
                this._restorePluginData[restoreList[i].requestId] = restoreList[i];
            }
        }else{
            this._isReady = true;
            this._isRestore = false;
        }

        callback();


    }

    get isRestore(){
        return this._isRestore;
    }

    get restorePluginData(){
        return this._restorePluginData;
    }

}

const instance = new AndroidRestore();

export default instance;